/* windows/windows.c */
/* Copyright (C) 1995 Eric Young (eay@mincom.oz.au)
 * All rights reserved.
 * 
 * This file is part of an SSL implementation written
 * by Eric Young (eay@mincom.oz.au).
 * The implementation was written so as to conform with Netscapes SSL
 * specification.  This library and applications are
 * FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 * as long as the following conditions are aheared to.
 * 
 * Copyright remains Eric Young's, and as such any Copyright notices in
 * the code are not to be removed.  If this code is used in a product,
 * Eric Young should be given attribution as the author of the parts used.
 * This can be in the form of a textual message at program startup or
 * in documentation (online or textual) provided with the package.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *    This product includes software developed by Eric Young (eay@mincom.oz.au)
 * 
 * THIS SOFTWARE IS PROVIDED BY ERIC YOUNG ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * 
 * The licence and distribution terms for any publically available version or
 * derivative of this code cannot be changed.  i.e. this code cannot simply be
 * copied and put under another distribution licence
 * [including the GNU Public Licence.]
 */

#ifdef _Windows

#ifndef _WINDLL
#define _WINDLL
#endif

#include <stdio.h>
#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#ifdef __BORLANDC__
int     _Cdecl _FARFUNC vsprintf(char _FAR *__buffer,
	const char _FAR *__format,void _FAR *__arglist);
#endif

#ifdef _Windows
static int (*app_fread)(char *,int, int, FILE *);
static int (*app_fwrite)(char *, int, int, FILE *);
static char *(*app_fgets)(char *, int n, FILE *);
#endif

int WIN_init(freadfunc,fwritefunc,fgetsfunc)
int (*freadfunc)(char *,int, int, FILE *);
int (*fwritefunc)(char *, int, int, FILE *);
char *(*fgetsfunc)(char *,int,FILE *);
	{
	app_fread=freadfunc;
	app_fwrite=fwritefunc;
	app_fgets=fgetsfunc;
	return(1);
	}

char *GETENV(var)
char *var;
	{
	char value[512];
	char *ret;

	if (GetPrivateProfileString("defaults",var,"",value,
		sizeof(value)-1,"SSLeay.ini") != 0)
		{
		value[sizeof(value)-1]='\0';
		ret=malloc(strlen(value));
		if (ret == NULL) return(NULL);
		strcpy(ret,value);
		return(ret);
		}
	else
		return(NULL);
	}

int WIN_fwrite(buf,size,count,fp)
char *buf;
int size;
int count;
FILE *fp;
	{
	return(app_fwrite(buf,size,count,fp));
	}

int WIN_fread(buf,size,count,fp)
char *buf;
int size;
int count;
FILE *fp;
	{
	return(app_fread(buf,size,count,fp));
	}

char *WIN_fgets(buf,size,fp)
char *buf;
int size;
FILE *fp;
	{
	return(app_fgets(buf,size,fp));
	}

int WIN_fputc(c,fp)
int c;
FILE *fp;
	{
	char data=c;

	return(WIN_fwrite(&data,1,1,fp));
	}

int FAR cdecl WIN_fprintf(FILE *fp,char *format, ... )
	{
	va_list ap;
	static char lbuf[2048];
	static char lformat[128+1];
	int i,t1,len;
	char *p;

	va_start(ap,format);

	/* make some stuff local so vsprintf is kept happy */
	strncpy(lformat,format,128);

	vsprintf((char *)lbuf,(char *)lformat,ap);
	va_end(ap);

	len=i=0;
	p=lbuf;
	for (;;)
		{
		if (p[i] == '\n')
			{
			t1=p[i+1];
			p[i+0]='\r';
			p[i+1]='\n';
			WIN_fwrite(p,i+2,1,fp);
			p[i+1]=t1;
			p= &(p[i+1]);
			i=0;
			}
		else if (p[i] == '\0')
			{
			if (i > 0) WIN_fwrite(p,i,1,fp);
			return(0);
			}
		else
			i++;
		}
	}

#endif

